/*
 * ProviewR   Open Source Process Control.
 * Copyright (C) 2005-2020 SSAB EMEA AB.
 *
 * This file is part of ProviewR.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ProviewR. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking ProviewR statically or dynamically with other modules is
 * making a combined work based on ProviewR. Thus, the terms and
 * conditions of the GNU General Public License cover the whole
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * ProviewR give you permission to, from the build function in the
 * ProviewR Configurator, combine ProviewR with modules generated by the
 * ProviewR PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every
 * copy of the combined work is accompanied by a complete copy of
 * the source code of ProviewR (the version used to produce the
 * combined work), being distributed under the terms of the GNU
 * General Public License plus this exception.
 */

/* sev_lognav.cpp -- Log file viewer */

#include "co_cdh.h"
#include "co_time.h"

#include "flow_browwidget_gtk.h"
#include "flow_msg.h"

#include "glow_growapi.h"
#include "glow_growwidget_gtk.h"

#include "xtt_log_gtk.h"

//
// Create the navigator widget
//
LogNavGtk::LogNavGtk(void* xn_parent_ctx, GtkWidget* xn_parent_wid,
    LogNav_hier *xn_tree, GtkWidget** w,
    pwr_tStatus* status)
    : LogNav(xn_parent_ctx, xn_tree, status),
      parent_wid(xn_parent_wid)
{
  form_widget
      = scrolledbrowwidgetgtk_new(LogNav::init_brow_cb, this, &brow_widget);

  gtk_widget_show_all(brow_widget);

  // Create the root item
  *w = form_widget;

  *status = 1;
}
//
//  Delete a nav context
//

LogNavGtk::~LogNavGtk()
{
  delete brow;
  gtk_widget_destroy(form_widget);
}

void LogNavGtk::set_inputfocus()
{
  gtk_widget_grab_focus(brow_widget);
}
